## jubatus-0.5.1.tar.gz

=== wscript ===
# -*- python -*-
import Options
from waflib.Errors import TaskNotReady
import os
import sys

VERSION = '0.5.1'
APPNAME = 'jubatus'

top = '.'
out = 'build'
subdirs = ['config', 'jubatus', 'plugin']

def options(opt):
  opt.load('compiler_cxx')
  opt.load('unittest_gtest')
  opt.load('gnu_dirs')

  opt.add_option('--enable-debug',
                 action='store_true', default=False,
                 dest='debug', help='build for debug')

  opt.add_option('--enable-zookeeper',
                 action='store_true', default=False, # dest='nozk',
                 help='use ZooKeeper')

  opt.add_option('--enable-gcov',
                 action='store_true', default=False,
                 dest='gcov', help='only for debug')

  opt.add_option('--enable-zktest',
                 action='store_true', default=False, 
                 dest='zktest', help='zk should run in localhost:2181')

  # use (base + 10) ports for RPC module tests
  opt.add_option('--rpc-test-port-base',
                 default=60023, choices=map(str, xrange(1024, 65535 - 10)),
                 help='base port number for RPC module tests')

  opt.add_option('--disable-eigen',
                 action='store_true', default=False,
                 dest='disable_eigen', help='disable internal Eigen and algorithms using it')

  opt.recurse(subdirs)

def configure(conf):
  conf.env.CXXFLAGS += ['-O2', '-Wall', '-g', '-pipe'];

  conf.load('compiler_cxx')
  conf.load('unittest_gtest')
  conf.load('gnu_dirs')

  # Generate config.hpp
  conf.env.JUBATUS_PLUGIN_DIR = conf.env['LIBDIR'] + '/jubatus/plugin'
  conf.define('JUBATUS_VERSION', VERSION)
  conf.define('JUBATUS_APPNAME', APPNAME)
  conf.define('JUBATUS_PLUGIN_DIR', conf.env.JUBATUS_PLUGIN_DIR)
  conf.write_config_header('jubatus/config.hpp', guard="JUBATUS_CONFIG_HPP_", remove=False)

  conf.check_cxx(lib = 'msgpack')
  conf.check_cxx(lib = 'jubatus_mpio')
  conf.check_cxx(lib = 'jubatus_msgpack-rpc')
  conf.check_cxx(lib = 'dl')

  # pkg-config tests
  conf.find_program('pkg-config') # make sure that pkg-config command exists
  try:
    conf.check_cfg(package = 'libglog', args = '--cflags --libs')
  except conf.errors.ConfigurationError:
    e = sys.exc_info()[1]
    conf.to_log("PKG_CONFIG_PATH: " + os.environ.get('PKG_CONFIG_PATH', ''))
    conf.fatal("Failed to find the library. Please confirm that PKG_CONFIG_PATH environment variable is correctly set.", e)

  conf.check_cxx(header_name = 'unistd.h')
  conf.check_cxx(header_name = 'sys/types.h')
  conf.check_cxx(header_name = 'sys/wait.h')
  conf.check_cxx(header_name = 'sys/stat.h')
  conf.check_cxx(header_name = 'cxxabi.h')
  conf.check_cxx(header_name = 'sys/socket.h net/if.h')
  conf.check_cxx(header_name = 'sys/ioctl.h')
  conf.check_cxx(header_name = 'fcntl.h')
  conf.check_cxx(header_name = 'netinet/in.h')
  conf.check_cxx(header_name = 'arpa/inet.h')
  conf.check_cxx(header_name = 'dlfcn.h')

  if not Options.options.debug:
    conf.define('NDEBUG', 1)
    conf.define('JUBATUS_DISABLE_ASSERTIONS', 1)

  if Options.options.enable_zookeeper:
    if (conf.check_cxx(header_name = 'c-client-src/zookeeper.h',
                           define_name = 'HAVE_ZOOKEEPER_H',
                           mandatory = False)):
      conf.define('ZOOKEEPER_HEADER', 'c-client-src/zookeeper.h')
    else:
      conf.check_cxx(header_name = 'zookeeper/zookeeper.h',
                     define_name = 'HAVE_ZOOKEEPER_H',
                     errmsg = 'ZooKeeper c-binding is not found. Please install c-binding.',
                     mandatory = True)
      conf.define('ZOOKEEPER_HEADER', 'zookeeper/zookeeper.h')

    conf.check_cxx(lib = 'zookeeper_mt', errmsg = 'ZK not found')

    if Options.options.zktest:
      conf.env.INTEGRATION_TEST = True

  if Options.options.gcov:
    conf.env.append_value('CXXFLAGS', '-fprofile-arcs')
    conf.env.append_value('CXXFLAGS', '-ftest-coverage')
    conf.env.append_value('LINKFLAGS', '-lgcov')

  if Options.options.rpc_test_port_base:
    conf.define('JUBATUS_RPC_TEST_PORT_BASE', int(Options.options.rpc_test_port_base))

  conf.define('BUILD_DIR',  conf.bldnode.abspath())

  conf.env.USE_EIGEN = not Options.options.disable_eigen
  if conf.env.USE_EIGEN:
    conf.define('JUBATUS_USE_EIGEN', 1)

  conf.recurse(subdirs)

def build(bld):

  bld(source = 'jubatus.pc.in',
      prefix = bld.env['PREFIX'],
      exec_prefix = '${prefix}',
      libdir = bld.env['LIBDIR'],
      includedir = '${prefix}/include',
      PACKAGE = APPNAME,
      VERSION = VERSION)

  bld(source = 'jubatus-client.pc.in',
      prefix = bld.env['PREFIX'],
      exec_prefix = '${prefix}',
      libdir = bld.env['LIBDIR'],
      includedir = '${prefix}/include',
      PACKAGE = APPNAME,
      VERSION = VERSION)

  bld(name = 'core_headers', export_includes = './')

  bld.recurse(subdirs)

def cpplint(ctx):
  import fnmatch, tempfile
  cpplint = ctx.path.find_node('tools/codestyle/cpplint/cpplint.py')
  src_dir = ctx.path.find_node('jubatus')
  file_list = []
  excludes = ['jubatus/server/third_party/*',
              'jubatus/server/server/*_impl.cpp',
              'jubatus/server/server/*_proxy.cpp',
              'jubatus/server/server/*_client.hpp',
              'jubatus/server/server/*_types.hpp',
              'jubatus/client/*_client.hpp',
              'jubatus/client/*_types.hpp',
              'jubatus/core/third_party/*',
              'jubatus/util/*.h',
              'jubatus/util/*.cpp',
              'jubatus/util/*/*.h',
              'jubatus/util/*/*.cpp',
              'jubatus/util/*/*/*.h',
              'jubatus/util/*/*/*.cpp']
  for file in src_dir.ant_glob('**/*.cpp **/*.cc **/*.hpp **/*.h'):
    file_list += [file.path_from(ctx.path)]
  for exclude in excludes:
    file_list = [f for f in file_list if not fnmatch.fnmatch(f, exclude)]
  tmp_file = tempfile.NamedTemporaryFile(delete=True);
  tmp_file.write("\n".join(file_list));
  tmp_file.flush()
  ctx.exec_command('cat ' + tmp_file.name + ' | xargs "' + cpplint.abspath() + '" --filter=-runtime/references,-runtime/rtti 2>&1')
  tmp_file.close()

def regenerate(ctx):
  server_node = ctx.path.find_node('jubatus/server/server')
  jenerator_node = ctx.path.find_node('tools/jenerator/src/jenerator')
  if not jenerator_node:
    raise TaskNotReady('jenerator is not built yet')
  for idl_node in server_node.ant_glob('*.idl'):
    idl = idl_node.name
    service_name = os.path.splitext(idl)[0]
    jenerator_command = [jenerator_node.abspath(), '-l', 'server', '-o', '.', '-i', '-n', 'jubatus', '-g', 'JUBATUS_SERVER_SERVER_', idl]
    try:
      idl_hash = ctx.cmd_and_log(['git', 'log', '-1', '--format=%H', '--', idl], cwd=server_node.abspath()).strip()
      idl_ver = ctx.cmd_and_log(['git', 'describe', idl_hash], cwd=server_node.abspath()).strip()
      jenerator_command += ['--idl-version', idl_ver]
    except Exception:
      pass
    ctx.cmd_and_log(jenerator_command, cwd=server_node.abspath())
    print()
    if not service_name in ['graph', 'anomaly']:
      server_node.find_node('%s_client.hpp' % service_name).delete()

def regenerate_client(ctx):
  server_node = ctx.path.find_node('jubatus/server/server')
  client_node = ctx.path.find_node('jubatus/client')
  jenerator_node = ctx.path.find_node('tools/jenerator/src/jenerator')
  if not jenerator_node:
    raise TaskNotReady('jenerator is not built yet')
  for idl_node in server_node.ant_glob('*.idl'):
    idl = idl_node.name
    service_name = os.path.splitext(idl)[0]
    jenerator_command = [jenerator_node.abspath(), '-l', 'cpp', '-o', client_node.abspath(), '-i', '-n', 'jubatus::' + service_name, '-g', 'JUBATUS_CLIENT_', idl]
    try:
      idl_hash = ctx.cmd_and_log(['git', 'log', '-1', '--format=%H', '--', idl], cwd=server_node.abspath()).strip()
      idl_ver = ctx.cmd_and_log(['git', 'describe', idl_hash], cwd=server_node.abspath()).strip()
      jenerator_command += ['--idl-version', idl_ver]
    except Exception:
      pass
    ctx.cmd_and_log(jenerator_command, cwd=server_node.abspath())
    print()

=== config/wscript ===
def options(opt):
  pass

def configure(conf):
  pass

def build(bld):
  bld.install_files('${PREFIX}/share/jubatus/example/config/',
                    bld.path.ant_glob('*/*.json'),
                    relative_trick=True)

=== jubatus/wscript ===
import Options

subdirs = "util core server client"

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)
  bld.install_files('${PREFIX}/include/jubatus',
                    ['config.hpp', 'client.hpp'])

=== plugin/wscript ===
subdirs = "src"

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)

=== jubatus/core/wscript ===
import Options

subdirs = "common anomaly classifier driver framework fv_converter graph recommender regression stat storage nearest_neighbor table clustering third_party"
def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)
  bld.install_files('${PREFIX}/include/jubatus/core',
                    ['plugin.hpp'])

=== jubatus/server/wscript ===
import Options

subdirs = '''
common framework cmd jubavisor server third_party
'''

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  bld.recurse(subdirs)
  bld.install_files('${PREFIX}/include/jubatus/server',
                    ['framework.hpp'])

=== jubatus/util/wscript ===
subdirs = [
  'lang',
  'concurrent',
  'system',
  'data',
  'math',
  'text',
  ]

def options(opt):
  pass

def configure(conf):
  env = conf.env
  env.append_unique('CXXFLAGS', ['-O2', '-Wall', '-g', '-pipe', '-D_REENTRANT', '-fno-omit-frame-pointer'])
  ver = env.CC_VERSION
  if env.COMPILER_CXX != 'g++' or int(ver[0]) < 4 or (int(ver[0]) == 4 and int(ver[1]) < 6):
    env.append_unique('CXXFLAGS', '-D_FORTIFY_SOURCE=1')

  env.HPREFIX = env.PREFIX + '/include/jubatus/util'
  conf.check_cxx(lib = 'pthread')

  conf.env.stash()
  try:
    for x in [y.split('=') for y in conf.env.DEFINES]:
      conf.env.define_key.remove(x[0])

    conf.recurse(subdirs)
    conf.write_config_header('util-config.h', guard = 'JUBATUS_UTIL_PFI_CONFIG_H_')
  finally:
    env.revert()

def build(bld):
  b = bld.shlib(
    source = 'empty.cpp',
    target = 'jubatus_util',
    vnum = bld.env['VERSION'],
    use = [
      'core_headers',
      'jubatus_util_concurrent',
      'jubatus_util_data',
      'jubatus_util_lang',
      'jubatus_util_math',
      'jubatus_util_system',
      'jubatus_util_text',
      ])
  bld.install_files('${HPREFIX}/', ['util-config.h'])

  bld.recurse(subdirs)

=== jubatus/core/anomaly/wscript ===
def options(ctx):
  pass

def configure(ctx):
  pass

def build(bld):
  if not bld.is_defined('JUBATUS_DISABLE_ASSERTIONS'):
    libassert = " LIBGLOG"
  else:
    libassert = ""

  bld.shlib(
    source = [
      'anomaly_base.cpp',
      'anomaly_factory.cpp',
      'light_lof.cpp',
      'lof.cpp',
      'lof_storage.cpp',
      ],
    target = 'jubatus_anomaly',
    name = 'jubatus_anomaly',
    includes = '.',
    use = 'jubatus_util jubastorage jubacommon jubatus_recommender jubatus_column_table'+libassert)

  def make_test(s):
    bld.program(
      features = 'gtest',
      source = s,
      target = s[0:s.rfind('.')],
      includes = '.',
      use = 'jubatus_util jubatus_anomaly jubacommon jubatus_recommender jubatus_mixables'+libassert)

  map(make_test, [
      'light_lof_test.cpp',
      'lof_storage_test.cpp',
      'lof_test.cpp',
      ])

  bld.install_files('${PREFIX}/include/jubatus/core/anomaly', [
      'anomaly_base.hpp',
      'anomaly_factory.hpp',
      'anomaly_type.hpp',
      ])

=== jubatus/core/classifier/wscript ===
def options(ctx): pass

def configure(ctx): pass

def build(bld):
  if not bld.is_defined('JUBATUS_DISABLE_ASSERTIONS'):
    libassert = " LIBGLOG"
  else:
    libassert = ""

  bld.shlib(
    source = '''
        classifier_base.cpp
	perceptron.cpp
	passive_aggressive.cpp
	passive_aggressive_1.cpp
	passive_aggressive_2.cpp
	confidence_weighted.cpp
	arow.cpp
	normal_herd.cpp
        classifier_factory.cpp
	''',
    target = 'jubatus_classifier',
    name = 'jubatus_classifier',
    includes = '.',
    use = 'jubatus_util jubacommon jubatus_mixables'+libassert)

  bld.program(
     features = 'gtest',
     source = [
         'classifier_test.cpp',
         'classifier_factory.cpp'
     ],
     target = "classifier_test",
     includes = '.',
     use = 'jubacommon jubatus_classifier jubastorage'+libassert)

  bld.install_files('${PREFIX}/include/jubatus/core/classifier', [
      'classifier_base.hpp',
      'classifier_factory.hpp',
      'classifier_type.hpp',
      'classifier_config.hpp',
      ])

=== jubatus/core/clustering/wscript ===
import os;
import re;

def options(opt): pass
def configure(conf):
    pass
def build(bld):
  source = [
    'clustering.cpp',
    'storage.cpp',
    'compressive_storage.cpp',
    'simple_storage.cpp',
    'storage_factory.cpp',
    'kmeans_compressor.cpp',
    'kmeans_clustering_method.cpp',
    'clustering_method_factory.cpp',
    'discrete_distribution.cpp',
    'util.cpp'
  ]
  if bld.env.USE_EIGEN:
    source += [
      'eigen_feature_mapper.cpp',
      'gmm_compressor.cpp',
      'gmm_clustering_method.cpp',
      'gmm.cpp',
    ]

  bld.shlib(
    source = source,
    target = 'jubatus_clustering',
    includes = '.',
    use = 'jubatus_util MSGPACK'
    )

  test_cases = [
    'mixable_model_test.cpp',
    'model_test.cpp',
    'storage_test.cpp'
  ]
  if bld.env.USE_EIGEN:
    test_cases += [
      'model_gmm_test.cpp'
    ]
  for t in test_cases:
    ret = re.compile("^(\w+)_test.cpp$").match(t);
    if ret is not None:
      tname = ret.groups()[0];
      target = "clustering_" + tname + "_test";
      bld.program(
        features="gtest",
        source= [
          t,
        ],
        target=target,
        includes=".",
        use="jubatus_util jubatus_clustering",
      );

=== jubatus/core/common/wscript ===

subdirs = ['jsonconfig']

def options(opt):
  opt.recurse(subdirs)

def configure(conf):
  conf.recurse(subdirs)

def build(bld):
  if not bld.is_defined('JUBATUS_DISABLE_ASSERTIONS'):
    libassert = " LIBGLOG"
  else:
    libassert = ""

  src = 'crc32.cpp exception.cpp key_manager.cpp vector_util.cpp version.cpp'
  src += ' jsonconfig/config.cpp jsonconfig/exception.cpp'

  bld.shlib(
    source = src,
    target = 'jubacommon',
    includes = '.',
    use = 'jubatus_util'+libassert
    )

  test_src = [
    'exception_test.cpp',
    'big_endian_test.cpp',
    'byte_buffer_test.cpp',
    'crc32_test.cpp',
    'key_manager_test.cpp',
    'vector_util_test.cpp',
    'jsonconfig_test.cpp',
    ]

  def make_test(s):
    bld.program(
      features = 'gtest',
      source = s,
      target = s[0:s.rfind('.')],
      includes = '.',
      use = 'jubacommon'+libassert
      )
  for s in test_src:
    make_test(s)

  bld.install_files('${PREFIX}/include/jubatus/core/common/', [
      'assert.hpp',
      'big_endian.hpp',
      'byte_buffer.hpp',
      'crc32.hpp',
      'exception.hpp',
      'exception_info.hpp',
      'hash.hpp',
      'jsonconfig.hpp',
      'key_manager.hpp',
      'type.hpp',
      'unordered_map.hpp',
      'vector_util.hpp',
      ])
  bld.recurse(subdirs)

=== jubatus/core/driver/wscript ===
def options(opt):
  pass

def configure(conf):
  pass

def build(bld):
  if not bld.is_defined('JUBATUS_DISABLE_ASSERTIONS'):
    libassert = " LIBGLOG"
  else:
    libassert = ""

  bld.shlib(
    source = [
      'mixable_versioned_table.cpp',
      'linear_function_mixer.cpp',
      ],
    target = 'jubatus_mixables',
    includes = '.',
    use = 'jubatus_util MSGPACK jubastorage jubatus_column_table'+libassert
    )

  source = [
      'classifier.cpp',
      'regression.cpp',
      'recommender.cpp',
      'stat.cpp',
      'anomaly.cpp',
      'graph.cpp',
      'nearest_neighbor.cpp',
      'clustering.cpp',
      ]

  bld.shlib(
    source = source,
    target = 'jubatus_driver',
    includes = '.',
    use = 'jubatus_util jubacommon MSGPACK jubaconverter jubastorage jubatus_classifier jubatus_regression jubatus_recommender jubatus_stat jubatus_anomaly jubatus_graph jubatus_clustering jubatus_mixables'+libassert
    )

  def make_test(t):
    bld.program(
      features='gtest',
      source=t + '.cpp',
      target=t,
      includes='.',
      use='jubatus_driver'+libassert
      )

  tests = [
    'linear_function_mixer_test',
    'anomaly_test',
    'classifier_test',
    'graph_test',
    'regression_test',
    'recommender_test',
    'stat_test',
    'nearest_neighbor_test',
    ]

  for t in tests:
    make_test(t)

  bld.install_files('${PREFIX}/include/jubatus/core/driver', [
      'classifier.hpp',
      'regression.hpp',
      'recommender.hpp',
      'stat.hpp',
      'anomaly.hpp',
      'graph.hpp',
      'diffv.hpp',
      'linear_function_mixer.hpp',
      'mixable_versioned_table.hpp',
      'nearest_neighbor.hpp',
      ])

=== tools/packaging/allinone/metadata/debian/control ===
Source: jubatus
Priority: extra
Maintainer: PFI & NTT <jubatus@googlegroups.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, pkg-config, python (>= 2.6)
Standards-Version: 3.9.3
Section: misc
Homepage: http://jubat.us/

Package: jubatus
Section: misc
Architecture: any
Depends: libc6 (>= 2.14), ${misc:Depends}
Description: Distributed processing framework and streaming machine learning library
 Jubatus is a distributed processing framework and streaming machine
 learning library.
